<?php
/**
* Web based SQLite management
* Some functions
* @package SQLiteManager
* @author Frdric HENNINOT
* @version $Id: common.lib.php,v 1.63 2004/11/21 16:53:00 freddy78 Exp $ $Revision: 1.63 $
*/

/**
* sqlite_query wrapper function
*
* @param resource $db resource connexion for SQLiteDatabase
* @param string $query SQL command string
*/
function SQLiteExecFunction($db, $query){
	if(substr(trim($query), -1) != ";") $query .= ";";
	if(DEBUG) return sqlite_query($db, $query);
	else return @sqlite_query($db, $query);
}

/**
* sqlite_num_rows wrapper function
*
* @param resource $res Result resource SQLite Database
*/
function SQLiteNumFunction($res){
	if(DEBUG) return sqlite_num_rows($res);
	else return @sqlite_num_rows($res);
}

/**
* sqlite_fetch_array wrapper function
*
* @param resource $res Result resource SQLite Database
* @param int $type Result method type, must be (SQLITE_ASSOC | SQLITE_NUM | SQLITE_BOTH)
*/
function SQLiteFetchFunction($res, $type=SQLITE_ASSOC){
	if(DEBUG) return sqlite_fetch_array($res, $type);
	else return @sqlite_fetch_array($res, $type);
}

/**
* sqlite_num_fields wrapper function
*
* @param resource $res Result resource SQLite Database
*/
function SQLiteNumFieldsFunction($res){
	if(DEBUG) return sqlite_num_fields($res);
	else return @sqlite_num_fields($res);
}

/**
* sqlite_field_name wrapper function
*
* @param resource $res Result resource SQLite Database
* @param int $i index
*/
function SQLiteFieldNameFunction($res, $i){
	if(DEBUG) return sqlite_field_name($res, $i);
	else return @sqlite_field_name($res, $i);
}

/**
* sqlite_array_query wrapper function
*
* @param resource $db resource connexion for SQLiteDatabase
* @param string $query SQL command string
* @param int $type Result method type, must be (SQLITE_ASSOC | SQLITE_NUM | SQLITE_BOTH)
*/
function SQLiteArrayFunction($db, $query, $type=SQLITE_ASSOC){
	if(DEBUG) return sqlite_array_query($db, $query, $type);
	else return @sqlite_array_query($db, $query, $type);
}

/**
* sqlite_fetch_string wrapper function
*
* @param resource $res Result resource SQLite Database
*/
function SQLiteStringFunction($res){
	if(DEBUG) return sqlite_fetch_string($res);
	else return @sqlite_fetch_string($res);
}

/**
* check if SQLite extension is loaded, and if not load it.
*/
function SQLIteCheckOk(){
	$SQL_SERVER_OS = strtoupper(substr(PHP_OS, 0, 3));
	if(substr(phpversion(), 0, 1) == "5") $extName = "sqlite";
	elseif($SQL_SERVER_OS == "LIN") $extName = "sqlite.so";
	elseif($SQL_SERVER_OS == "WIN") $extName = "php_sqlite";
	if (!extension_loaded($extName) && !in_array("sqlite", get_loaded_extensions())) {
    	if (@dl($extName)) {
    	    return true;
    	} else {
			return false;
		}
	} else return true;
}

/**
* Display error message
* 
* @param string $message 
*/
function displayError($message){
	echo '
	<center>
		<table width="80%" style="border: 1px solid red">
			<tr><td align="center"><b>'.$GLOBALS["traduct"]->get(9).' :</b></td></tr>
			<tr><td align="left"><span style="color: red"><b>'.$message.'</b></span></td></tr>
		</table>
	</center>';
	return;
}

/**
* return the condition
*/
function displayCondition($authType){
	global $SQLiteManagerAuth;
	return (!WITH_AUTH || (
							isset($SQLiteManagerAuth) &&  $SQLiteManagerAuth->getAccess($authType)
							));
 }

/**
* Display the global menu on the right pan, it' dependant of context
*/
function displayMenuTitle(){
	global $SQLiteManagerAuth, $workDb;
	$linkBase = "main.php?dbsel=".$GLOBALS["dbsel"];
	foreach($GLOBALS["dbItems"] as $Items) if(isset($GLOBALS[strtolower($Items)])) $linkBase .= "&".strtolower($Items)."=".$GLOBALS[strtolower($Items)];
	echo "	<div align=\"center\">
				<table width=80% style=\"border-bottom: 1px solid black\">
					<tr>
						<td width=10%>&nbsp;</td>";
	if(isset($GLOBALS["table"]) && ($GLOBALS["table"]!="")){
		if(isset($_REQUEST["currentPage"])) $valCurrent = $_REQUEST["currentPage"];
		else $valCurrent = $GLOBALS["action"];
		echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>\n";
		echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=browseItem\" target=\"main\">".$GLOBALS["traduct"]->get(73)."</a></td>\n";
		if(displayCondition("execSQL")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>".$GLOBALS["traduct"]->get(74)."</i></td>\n";
		if(displayCondition("select")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=select\" target=\"main\">"."Select"."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>"."Select"."</i></td>\n";        
		if(!$workDb->isReadOnly() && displayCondition("data")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=insertElement&currentPage=".$valCurrent."\" target=\"main\">".$GLOBALS["traduct"]->get(75)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>".$GLOBALS["traduct"]->get(75)."</i></td>\n";
		if(displayCondition("export")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>".$GLOBALS["traduct"]->get(76)."</i></td>\n";
		if(!$workDb->isReadOnly() && displayCondition("empty")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(79)."')) parent.main.location='".$linkBase."&action=empty';\">".$GLOBALS["traduct"]->get(77)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>".$GLOBALS["traduct"]->get(77)."</i></td>\n";
		if(!$workDb->isReadOnly() && displayCondition("del")) echo "			<td class=\"proptitle\" align=\"center\" width=11%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(80)."')) parent.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
		else echo "			<td class=\"proptitle\" align=\"center\" width=11%><i>".$GLOBALS["traduct"]->get(15)."</i></td>";
	} elseif(isset($GLOBALS["view"]) && ($GLOBALS["view"]!="")) {
		echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>\n";
		echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=browseItem\" target=\"main\">".$GLOBALS["traduct"]->get(73)."</a></td>\n";
		if(displayCondition("execSQL")) echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=13%><i>".$GLOBALS["traduct"]->get(74)."</i></td>\n";
		if(displayCondition("export")) echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=13%><i>".$GLOBALS["traduct"]->get(76)."</i></td>\n";
		if(displayCondition("properties")) echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=13%><i>".$GLOBALS["traduct"]->get(81)."</i></td>\n";
		if(!$workDb->isReadOnly() && displayCondition("del")) echo "			<td class=\"proptitle\" align=\"center\" width=13%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(82)."')) parent.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
		else echo "			<td class=\"proptitle\" align=\"center\" width=13%><i>".$GLOBALS["traduct"]->get(15)."</i></td>";
	} elseif(isset($GLOBALS["function"]) && ($GLOBALS["function"]!="")) {
		echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>\n";
		if(displayCondition("execSQL")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(74)."</i></td>\n";
		if(displayCondition("export")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(76)."</i></td>\n";
		if(displayCondition("properties")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(81)."</i></td>\n";
		if(!$workDb->isReadOnly() && displayCondition("del")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(78)."')) parent.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(15)."</i></td>";
	} elseif(isset($GLOBALS["trigger"]) && ($GLOBALS["trigger"]!="")) {
		echo "			<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>\n";
		if(displayCondition("execSQL")) echo "			<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=20%><i>".$GLOBALS["traduct"]->get(74)."</i></td>\n";
		if(displayCondition("properties")) echo "			<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"".$linkBase."&action=add\" target=\"main\">".$GLOBALS["traduct"]->get(81)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=20%><i>".$GLOBALS["traduct"]->get(81)."</i></td>\n";
		if(!$workDb->isReadOnly() && displayCondition("del")) echo "			<td class=\"proptitle\" align=\"center\" width=20%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(83)."')) parent.main.location='".$linkBase."&action=delete';\">".$GLOBALS["traduct"]->get(15)."</a></td>";
		else echo "			<td class=\"proptitle\" align=\"center\" width=20%><i>".$GLOBALS["traduct"]->get(15)."</i></td>";
	} else {
		echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=properties\" target=\"main\">".$GLOBALS["traduct"]->get(72)."</a></td>\n";
		echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=options\" target=\"main\">".$GLOBALS["traduct"]->get(84)."</a></td>\n";
		if(displayCondition("execSQL")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=sql\" target=\"main\">".$GLOBALS["traduct"]->get(74)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(74)."</i></td>\n";
		if(displayCondition("export")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"".$linkBase."&action=export\" target=\"main\">".$GLOBALS["traduct"]->get(76)."</a></td>\n";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(76)."</i></td>\n";
		if(!READ_ONLY && displayCondition("del")) echo "			<td class=\"proptitle\" align=\"center\" width=16%><a class=\"titleHeader\" href=\"#\" onClick=\"if(confirm('".$GLOBALS["traduct"]->get(85)."')) parent.main.location='".$linkBase."&action=del';\">".$GLOBALS["traduct"]->get(86)."</a></td>";
		else echo "			<td class=\"proptitle\" align=\"center\" width=16%><i>".$GLOBALS["traduct"]->get(86)."</i></td>";
	}
	
	echo "				<td width=10%>&nbsp;</td>
					</tr>
				</table>
			</div>";
}

/**
* Display pan header
*
* @param string $frame target where the header will be display
* @param bool $withTitle display title
*/
function displayHeader($frame, $withTitle=true){
	global $workDb;
	?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
	<head>
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="expires" content="0">	<meta http-equiv="content-type" content="text/html;charset=<?php echo $GLOBALS["charset"] ?>">	
	<link href="theme/<?php echo $GLOBALS["localtheme"]."/".$frame ?>.css" rel="stylesheet" type="text/css">
	<script src="include/function.js" type="text/javascript" language="javascript"></script>
	</head>

	<body>
	<?php
	if( ($frame == "main") && ($withTitle) && ($GLOBALS["dbsel"]) ){
		echo "<h2>".$GLOBALS["traduct"]->get(131)." : <a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."\" style=\"text-decoration: none\"><span style='color: red'>".$GLOBALS["tabInfoDb"]["name"]."</span></a>";
		foreach($GLOBALS["dbItems"] as $Items) {
			if(!empty($GLOBALS[strtolower($Items)])) echo " - ".$GLOBALS["itemTranslated"][$Items]." <a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&".strtolower($Items)."=".$GLOBALS[strtolower($Items)]."\" style=\"text-decoration: none\"><span style='color: blue'>".$GLOBALS[strtolower($Items)]."</span></a>";		
		}
		echo "</h2>\n";
		if($workDb->isReadOnly()){
			echo "<table width=80% align='center'><tr><td style='font-size: 10px; border: 1px solid red; color: red; align: center'>".$GLOBALS["traduct"]->get(155)."</td></tr></table>";
		}
	}
}

/**
* Display add form dependent of context
*
* @param string $type represent the context
*/
function formAddItem($type){
	switch($type){
		case "Table":
			echo "<form name=\"add".$type."\" method=\"POST\"><span style='font-size: 12px'>".$GLOBALS["traduct"]->get(43)." ==>&nbsp;".$GLOBALS["traduct"]->get(19)." : <input type=\"text\" name=\"TableName\" size=20 class=\"small-input\"> - <input type=\"text\" name=\"nbChamps\" size=3 class=\"small-input\">&nbsp;".$GLOBALS["traduct"]->get(44)."&nbsp;<input class=\"button\" type=\"submit\" value=\"".$GLOBALS["traduct"]->get(69)."\"><input type=\"hidden\" name=\"dbsel\" value=\"".$GLOBALS["dbsel"]."\"><input type=\"hidden\" name=\"action\" value=\"add_".strtolower($type)."\"></span></form>";
			break;
		case "View":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_view\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(87)."</a>";
			break;
		case "Trigger":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_trigger\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(88)."</a>";
			break;
		case "Function":
			echo "<a href=\"main.php?dbsel=".$GLOBALS["dbsel"]."&action=add_function\" class='propItemTitle'>&nbsp;&raquo;&nbsp;".$GLOBALS["traduct"]->get(89)."</a>";
			break;
	}
}

/**
* Display query has been execute
*
* @param string $query
* @param bool $withLink if true some links will be display
*/
function displayQuery($query, $withLink=true){
	global $SQLiteManagerAuth; 
	if(empty($query) && isset($GLOBALS["DisplayQuery"])) $query = $GLOBALS["DisplayQuery"];
	$linkBase = "main.php?dbsel=".$GLOBALS["dbsel"]."&table=".$GLOBALS["table"];
	if($posLim = strpos($query, "LIMIT")) {
		$queryLink = substr($query, 0, ($posLim-1));
	} else $queryLink = $query;
	if(isset($GLOBALS["DbGrid"]) && is_object($GLOBALS["DbGrid"])){
		if(!empty($GLOBALS["DbGrid"]->infoNav["start"]) || !empty($GLOBALS["DbGrid"]->infoNav["end"]) || !empty($GLOBALS["DbGrid"]->infoNav["all"])){
			$infoNav = "<span style=\"font-size: 12px\">".$GLOBALS["traduct"]->get(136)." ".$GLOBALS["DbGrid"]->infoNav["start"]."-".$GLOBALS["DbGrid"]->infoNav["end"]."/".$GLOBALS["DbGrid"]->infoNav["all"]."&nbsp;&nbsp;</span>";
		}
	}
	if(!isset($infoNav)) $infoNav = "";
	if(WITH_AUTH && isset($SQLiteManagerAuth) &&  !$SQLiteManagerAuth->getAccess("execSQL")) $withLink = false;
	$modifyLink = "[<a href=\"".$linkBase."&action=sql&sql_action=modify&displayResult=&DisplayQuery=".urlencode($queryLink)."\" class='titleHeader'>".$GLOBALS["traduct"]->get(14)."</a>]";
	$explainLink = "[<a href=\"".$linkBase."&action=sql&sql_action=explain&displayResult=1&DisplayQuery=".urlencode($queryLink)."\" class='titleHeader'>".$GLOBALS["traduct"]->get(145)."</a>]";
	echo "
		<table width=60% align=\"center\" style='margin-top: 10px'>
			<tr>
				<td bgcolor=\"".$GLOBALS["displayQueryTitleColor"]."\"  nowrap=\"nowrap\">
					".$GLOBALS["traduct"]->get(90)." : ".(($withLink)? "&nbsp;&nbsp;".$infoNav.$modifyLink."&nbsp;".$explainLink : "" )."</td></tr>
			<tr><td bgcolor=\"".$GLOBALS["displayQueryBgColor"]."\" nowrap=\"nowrap\"><div class=\"sqlsyntaxe\">".highlight_query($query)."</div></td></tr>
		</table><br>
		";
}

/**
* highlight query for a proch future!!
*
* @param string $query SQL command string
*/
function highlight_query($query){
	include_once INCLUDE_LIB."ParsingQuery.class.php";
	$Colorize =& new ParsingQuery($query, 1);
	$Colorize->explodeQuery();
	$Colorize->colorWordList();
	return $Colorize->highlightQuery();
}

/**
* Display function list for the insert / modify form
*
* @param string $champ name of the current champ
*/
function SQLiteFunctionList($champ, $userDefine=""){
	$out = "<select name='funcs[".$champ."]'>\n
				<option value=''></option>\n";
	foreach($GLOBALS["SQLfunction"] as $funct) $out .= "<option value='".$funct."'>".$funct."</option>\n";	
	$tabUDF = $GLOBALS["workDb"]->functInfo;
	$out .= "<option value=''></option>\n";	
	if(is_array($tabUDF)) foreach($tabUDF as $udfInfo) if($udfInfo["funct_type"]==1) $out .= "<option value='".$udfInfo["funct_name"]."'>".$udfInfo["funct_name"]."</option>";
	$out .= "</select>";
	return $out;
}

/**
* Display operator list for the select form
* @author Maurcio M. Maia <mauricio.maia@gmail.com>
*
* @param string $champ name of the current champ
*/
function SQLiteSelectList($champ, $userDefine=""){
	$out = "<select name='operats[".$champ."]'>\n
				<option value=''></option>\n";
	foreach($GLOBALS["SQLselect"] as $operat) $out .= "<option value='".$operat."'>".$operat."</option>\n";	
	$out .= "<option value=''></option>\n";	
	$out .= "</select>";
	return $out;
}

/**
* Display input TYPE for the insert / modify form
*
* @param array $info data info for the current champ
* @param mixed $data current value of the champ
*/
function SQLiteInputType($info, $data, $allowDefault=true){
	static $tabIndex;
	if(empty($tabIndex)) $tabIndex = 1;
	if( (substr($info["type"],0,4)=="CHAR") || (substr($info["type"],0,7)=="VARCHAR") ) {
		preg_match("/\((.*)\)/", $info["type"], $length);
		if($length[1]){		
			$maxlength = "maxlength=".$length[1];
			if($length[1]<=20) $maxlength = " size=".($length[1]+1)." ".$maxlength;
		} else $maxlength = " size=20";
	} else $maxlength = " size=20";
	
	if($allowDefault && $info["notnull"] && ($data == '')){
		if(strstr($info["type"], "(")) {
			$localType = trim(preg_replace("/\(.*\)/", "", $info["type"]));
		} else {
			$localType = $info["type"];
		}
		if($info["dflt_value"]!= "") $data = $info["dflt_value"];
		elseif(isset($GLOBALS["SQLiteType"][$localType])) $data=$GLOBALS["SQLiteType"][$localType];
	}
	if((strtoupper(substr($info["type"],0,4))!="TEXT") && (strtoupper(substr($info["type"],0,4))!="BLOB")) {
		$out = "<input type=\"text\" name=\"valField[".$info["name"]."]\" value=\"".$data."\"".$maxlength." tabindex=".($tabIndex++).((!$info["notnull"])? " onChange=\"if(this.value!='') setCheckBox('editElement', 'nullField[".$info["name"]."]', false); else setCheckBox('editElement', 'nullField[".$info["name"]."]', true);\"" : "" ).">";
	} else {
		$out = "<textarea name=\"valField[".$info["name"]."]\" cols=".$GLOBALS["textareaCols"]." rows=".$GLOBALS["textareaRows"]." tabindex=".($tabIndex++).((!$info["notnull"])? " onChange=\"if(this.value!='') setCheckBox('editElement', 'nullField[".$info["name"]."]', false); else setCheckBox('editElement', 'nullField[\'".$info["name"]."\']', true);\"" : "" ).">".$data."</textarea>";
	
	}
	return $out;
}

/**
* Return Available language
*/
function getAvailableLanguage(){
	$out = "";
	$listLangue = $GLOBALS["langueTranslated"];
	natsort($listLangue);
	while(list($lgId, $lgLib) = each($listLangue)){
		$out .= "<option value=\"".$lgId."\"".(($GLOBALS["currentLangue"]==$lgId)? " selected" : "" ).">".(($GLOBALS["langueTranslated"][$lgId])? $GLOBALS["langueTranslated"][$lgId] : $lgLib)."</option>\n";
	}
	return $out;
}

/**
* Return available theme
*/
function getAvailableTheme(){
	$out = "";
	natsort($GLOBALS["availableTheme"]);
	while(list($themeId, $themeLib) = each($GLOBALS["availableTheme"])){
		$out .= "<option value=\"".$themeId."\"".(($GLOBALS["localtheme"]==$themeId)? " selected" : "" ).">".$themeLib."</option>\n";
	}
	return $out;
}

/**
* Apply a function from record form
*
* @param string $function the function name
* @param mixed $value paramaters to apply function
*/
function applyFunction($function, $value){
	$newValue = $value;
	if(in_array($function, $GLOBALS["SQLfunction"])){
		if($function == "MD5") $newValue = "php('md5', $value)";
		elseif($function == "NOW") $newValue = "php('date', 'Y-m-d')";
		else $newValue = strtolower($function)."($value)";
	} else {
		foreach($GLOBALS["workDb"]->functInfo as $functInfo) {
			if($function == $functInfo["funct_name"]) $newValue = $function."('$value')";
		}
	}
	return $newValue;
}

/**
* Convert a hash table to GET url string
*
* @param array $tab table of key=>value
*/
function arrayToGet($tab){
	$strOut = array();
	while(list($var, $value) = each($tab)) $strOut[] = $var."=".$value;
	return implode("&", $strOut);	
}

/**
* Cleaning field name, remove non authorized caractere
*
* @param string string is the field name
* @param string $allow PCRE representation of caractre authorized
*/
function cleanFieldName($string, $allow = "a-z_0-9[[:space:]]"){
	return eregi_replace("[^".$allow."]", "", trim($string));
}

/**
* Return a tab with all position of a caractere
*
* @param string $string haystack string
* @param char $seperation needle string to find
*/
function strpos_all($string, $separator){
	static $tabPos=array();
	$pos = strpos($string, $separator);
	if((string)$pos!=""){
	if(count($tabPos)>=1) $addPrec = ($tabPos[count($tabPos)-1] +1);
	else $addPrec = 0;
		array_push($tabPos, ($pos + $addPrec));
		$substring = substr($string, ($pos + 1), (strlen($string) - ($pos+1)) );
		strpos_all($substring, $separator);		
	}
	return $tabPos;
}

/**
* Function for error handling
* return PHP error from SQLite error to enhancement error displaying
*/
function phpSQLiteErrorHandling($errno, $errstr, $errfile, $errline){
	preg_match("/:(.*)/", $errstr, $errorResult);
	$GLOBALS["phpSQLiteError"] = $errorResult[1];
}

/**
* Create SELECT from array value
*
* @param array $tabData array("ID"=>"VALUE", ...)
* @param string form $varNamevar name
* @param int $varValue value to selected
* @return string HTML out
*/
function createSelect($tabData, $varName, $varValue){
	$out = "";
	if(isset($tabData) && !empty($tabData)){
		$out .= "<SELECT name='".$varName."'>\n<option value=''></option>\n";
		foreach($tabData as $id=>$value) $out .= "<option value='".$id."'".(($id==$varValue)? " selected" : "" ).">".$value."</option>\n";
		$out .="</SELECT>\n";
	}
	return $out;
}

/**
* Send image HTML!
* if exist img filename in theme, this is display also the './pics/'.$filename is display
* 
* @param string $src filename
* @param sring $alt string is display when mouse over
* @param int $border image border size in px
* @param int $width width size in px
* @param int height heigh size in px
* @return string img HTML tag 
*/
function displayPics($src, $alt="", $border=0, $width="", $height=""){
	$filename = basename($src);
	if(file_exists("./theme/".$GLOBALS["localtheme"]."/pics/".$filename)){
		$imgSrc = "./theme/".$GLOBALS["localtheme"]."/pics/".$filename;
	} else {
		$imgSrc = "./theme/default/pics/".$filename;
	}
	return '<img src="'.$imgSrc.'" border='.$border.' alt="'.$alt.'" title="'.$alt.'"'.(($width)? ' width='.$width : '' ).(($height)? ' height='.$height : '' ).'>';
}

/**
*  Add brackets when spaces in objects, remove existing ones for concatenations [table].[col] > [table.col]
*
* @param string $object object with or without bracket
* @return string object with brackets
*/
function brackets($object,$type=''){
	$object = ereg_replace('\[|\]','',$object);
	if (strstr($object,' ')) {
		$object = "[$object]";
	}
	return $object;
}
?>
